;===========================================================================================
; mouse1.asm  Nasm assembler
; Dtection click gauche souris
; Programm par AsmGges France                     http://www.chez.com/asmgges/index.htm
;===========================================================================================
; Compile:
; ..\..\bin\nasmw -f bin mouse1.asm -o mouse1.exe    
;===========================================================================================

%define ONLY_NASM 
%include "..\..\inc\nagoa+.inc"
%include "..\..\inc\defines.inc"

;Dclaration des procdures utilises par le programme
;-----------------------------------------------------
def ZeroMemory
def StrLen

;===========================================================================================
; Dbut du code programme
; -----------------------
section .code

start:

    ; Obtenir le handle du programme
    ; ------------------------------
    invoke GetModuleHandle,0
    mov [wc+WNDCLASS.hInstance],eax

    ; Initialiser la structure pour Windows
    ; -------------------------------------
    call ZeroMemory,wc,WNDCLASS_size
    mov D[wc+WNDCLASS.lpfnWndProc],WindowProc
    mov D[wc+WNDCLASS.hbrBackground],COLOR_WINDOW+1
    mov D[wc+WNDCLASS.lpszClassName],ClassName

    ; Chargement d'une icne
    ; ----------------------
    invoke LoadImage,[wc+WNDCLASS.hInstance],FranceFile,IMAGE_ICON,0,0,LR_LOADFROMFILE
    mov [wc+WNDCLASS.hIcon],eax

    ; Chargement d'un curseur
    ; -----------------------
    invoke LoadCursor,0,IDC_ARROW
    mov [wc+WNDCLASS.hCursor],eax
  
    ; Obtenir la largeur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CXSCREEN
    sub eax,[WinW]
    shr eax,1
    mov [WinX],eax

    ; Obtenir la hauteur en pixels de l'cran
    ; ---------------------------------------
    invoke GetSystemMetrics,SM_CYSCREEN
    sub eax,[WinH]
    shr eax,1
    mov [WinY],eax

    ; Valider le choix de la structure WNDCLASS
    ; -----------------------------------------
    invoke RegisterClass,wc

    ; Cration de la fentre de l'application
    ; ---------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,ClassName,Title,WS_OVERLAPPEDWINDOW+WS_VISIBLE,\
                          [WinX],[WinY],[WinW],[WinH],0,0,[wc+WNDCLASS.hInstance],0

    mov [hWnd],eax

    ; Affichage de la fentre
    ; -----------------------
    invoke ShowWindow,[hWnd],SW_SHOWDEFAULT

    ; Rafraichissement de la fentre
    ; ------------------------------
    invoke UpdateWindow,[hWnd]

 ;----------------------------------
 ; Boucle de traitement des messages
 ;----------------------------------
 MessageLoop:
    ; Rceptionne les messages
    ; ------------------------
    invoke GetMessage,msg,0,0,0
    or eax,eax
    jz ExitProgram

    ; Traduit les touches d'entre clavier en messages
    ; ------------------------------------------------
    invoke TranslateMessage,msg

    ; Expdition des messages  la procdure Windows
    ; ---------------------------------------------
    invoke DispatchMessage,msg

    jmp MessageLoop

 ExitProgram:
    ; Fermeture de l'application
    ; --------------------------
    invoke ExitProcess,[msg+MSG.wParam]

;===========================================================================================
; Procdure principale Windows
;-------------------------------------------------------------------------------------------
proc WindowProc, hWnd, uMsg, wParam, lParam
    uses ebx,esi,edi

    .if D[@uMsg],e,WM_CLOSE
        ; Boite  message fin d'application
        ; ---------------------------------
        invoke MessageBox,[@hWnd],MsgEnd,ClassName,MB_OK+MB_ICONINFORMATION

        ; Demande la fin de l'application
        ; ------------------------------
        invoke PostQuitMessage,0

    .elseif D[@uMsg],e,WM_LBUTTONDOWN
        ; Calculer les coordonnes du point
        ; ---------------------------------
        push D[@lParam]
        mov D[point+POINT.x],0
        mov D[point+POINT.y],0
        pop W[point+POINT.x]
        pop W[point+POINT.y]
        sub W[point+POINT.y],10
        mov D[MouseClick],1

        ; Redessiner la totalit du secteur client fenetre
        ; ------------------------------------------------
        invoke InvalidateRect,[@hWnd],0,1

    .elseif D[@uMsg],e,WM_PAINT
        ; Dbut criture/dessin
        ; ---------------------
        invoke BeginPaint,[@hWnd],ps

        .if D[MouseClick],e,1
            ; Fixer la couleur du texte
            ; -------------------------
            RGB 255,000,000
            invoke SetTextColor,[ps+PAINTSTRUCT.hdc],eax

            ; Obtenir la longueur de la chaine
            ; --------------------------------
            call StrLen,ClickStr

            ; Ecriture dans la fenetre
            ; ------------------------
            invoke TextOut,[ps+PAINTSTRUCT.hdc],[point+POINT.x],[point+POINT.y],ClickStr,eax

        .endif

        ; Fin criture/dessin
        ; -------------------
        invoke EndPaint,[@hWnd],ps

    .else
        ; Traitement par dfaut des autres messages Windows
        ; ------------------------------------------------
        invoke DefWindowProc,[@hWnd],[@uMsg],[@wParam],[@lParam]
        return

    .endif

    mov eax,0

endproc
;===========================================================================================
; Mettre  zro une zone mmoire
;-------------------------------------------------------------------------------------------
; @AdrZone = adresse zone mmoire  mettre  zro
; @Len     = longueur de la zone en octets
;===========================================================================================
proc ZeroMemory, AdrZone, Len
    uses ecx,edi

    mov edi,[@AdrZone]
    mov ecx,[@Len]
    mov eax,0
    rep stosb

endproc
;===========================================================================================
; Obtenir la longueur d'une chaine
;-------------------------------------------------------------------------------------------
; AdrStr  = Adresse de la chaine
; ==> eax = longueur de la chaine
;-------------------------------------------------------------------------------------------
proc StrLen, AdrStr
    uses ecx,esi

    mov esi,[@AdrStr]
    mov ecx,0

    .repeat
        lodsb
        inc ecx
    .until al,e,0

    dec ecx
    mov eax,ecx

endproc
;===========================================================================================
; Dfinitions des datas chaines / variables initialises ou non initialises / structures
; ------------------------------------------------------------------------------------------
section .data

  Title      db ' Cliquez dans la fentre !',0
  ClassName  db ' AsmGges Win32',0
  MsgEnd     db ' Nasm AsmGges France @2006  ',0
  ClickStr   db '<-- Vous avez cliqu ici ! ',0
  FranceFile db 'res\france.ico',0
  align 4

  WinX       dd 0
  WinY       dd 0
  WinW       dd 512
  WinH       dd 352

section .bss

  MouseClick resb 1
  hWnd       resb 1
  wc         resb WNDCLASS_size    
  msg        resb MSG_size 
  ps         resb PAINTSTRUCT_size
  point      resb POINT_size
      
;===========================================================================================
; Inclusion des fichiers .dll contenant les fonctions Windows utilises
;-------------------------------------------------------------------------------------------

LAST_BEGIN

__LIBS_   kernel32,'kernel32.DLL',\
          user32,  'user32.DLL',\
          gdi32,   'gdi32.DLL'

__IMPORT_ kernel32,\
          ExitProcess,'ExitProcess',0,\
          GetModuleHandle,'GetModuleHandleA',0

__IMPORT_ user32,\
          CreateWindowEx,'CreateWindowExA',0,\
          BeginPaint,'BeginPaint',0,\
          DefWindowProc,'DefWindowProcA',0,\
          DispatchMessage,'DispatchMessageA',0,\
          EndPaint,'EndPaint',0,\
          GetMessage,'GetMessageA',0,\
          GetSystemMetrics,'GetSystemMetrics',0,\
          InvalidateRect,'InvalidateRect',0,\
          LoadCursor,'LoadCursorA',0,\
          LoadImage,'LoadImageA',0,\
          MessageBox,'MessageBoxA',0,\
          PostQuitMessage,'PostQuitMessage',0,\
          RegisterClass,'RegisterClassA',0,\
          ShowWindow,'ShowWindow',0,\
          TranslateMessage,'TranslateMessage',0,\
          UpdateWindow,'UpdateWindow',0,\
          WaitMessage,'WaitMessage',0

__IMPORT_ gdi32,\
          SetTextColor,'SetTextColor',0,\
          TextOut,'TextOutA',0

LAST_END

;===========================================================================================
;///////////////////////////////////////////////////////////////////////////////////////////
;===========================================================================================